﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="index.aspx.cs" Inherits="aspnet_gridview_update_jquery_index" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>jQuery to update records from inside the GridView | YogiHosting Demo</title>
    <link rel="icon" type="image/png" href="http://www.yogihosting.com/wp-content/themes/yogi-yogihosting/Images/favicon.ico" />
    <style>
        body {
            background: #111 no-repeat;
            background-image: -webkit-gradient(radial, 50% 0, 150, 50% 0, 300, from(#444), to(#111));
        }

        h1, h2, h3 {
            text-align: center;
            color: #FFF;
        }

            h2 a {
                color: #0184e3;
                text-decoration: none;
            }

                h2 a:hover {
                    text-decoration: underline;
                }

            h3 a {
                color: #00e8ff;
                text-decoration: none;
            }

                h3 a:hover {
                    text-decoration: underline;
                }

        .container {
            width: 900px;
            margin: auto;
            color: #FFF;
            font-size: 25px;
        }

            .container h3 {
                font-size: 20px;
            }

        #content {
            position: relative;
            border: dashed 2px #CCC;
        }

            #content #loadingImg {
                display: none;
                position: absolute;
                margin: auto;
                top: 0;
                left: 0;
                right: 0;
                bottom: 0;
            }

        table {
            font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
            border-collapse: collapse;
            width: 100%;
        }

            table td, table th {
                border: 1px solid #ddd;
                padding: 8px;
            }

            table tr {
                background-color: #2549f6;
            }

            table th {
                padding-top: 12px;
                padding-bottom: 12px;
                text-align: left;
                background-color: #4CAF50;
                color: white;
            }

        .paging table {
            width: 70px;
        }

        #reset {
            padding: 5px 10px;
            background: #4CAF50;
            border: none;
            color: #FFF;
            cursor: pointer;
        }

            #reset:hover {
                color: #4CAF50;
                background: #FFF;
            }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <h1>jQuery to update records from inside the GridView</h1>
        <h2><a href="http://www.yogihosting.com/jquery-update-record-inside-gridview/">Read the tutorial on YogiHosting »</a></h2>
        <h3>
            <a id="reset">Reset »</a>
        </h3>
        <div class="container">
            <div id="content">
                <asp:GridView ID="gridView" runat="server" AutoGenerateColumns="false" OnPageIndexChanging="gridView_PageIndexChanging" AllowPaging="true" PageSize="5" PagerStyle-CssClass="paging">
                    <Columns>
                        <asp:BoundField DataField="Id" HeaderText="Id" />
                        <asp:TemplateField HeaderText="Name">
                            <ItemTemplate>
                                <asp:Label ID="nameLabel" runat="server" Text='<%#Bind("Name") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Quantity">
                            <ItemTemplate>
                                <asp:Label ID="TxtQuantity" runat="server" Text='<%# Bind("Quantity") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Price">
                            <ItemTemplate>
                                $<asp:Label ID="TxtPrice" runat="server" Text='<%# Bind("Price") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Edit" ItemStyle-CssClass="editColumn">
                            <ItemTemplate>
                                <asp:Button ID="editButton" runat="server" Text="Edit"></asp:Button>
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
                <img id="loadingImg" src="http://www.demo.yogihosting.com/aspnet/bind-gridview-with-jquery-ajax/loading.gif" style="display: none" />
            </div>
        </div>

        <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
        <script>
            $(function () {
                $("#reset").click(function (e) {
                    location.reload();
                });

                $("#<%=gridView.ClientID %> .editColumn input[type='submit']").click(function () {
                    removeButtons();
                    addButtons($(this));
                    resetBack();

                    var tds = $(this).parents("tr").find("td");
                    $(tds).each(function (index, value) {
                        var span = $(value).find("span");
                        if (span.length > 0) {
                            span.parent().append("<input class='added' type='text' value='" + span.text() + "'>");
                            span.hide();
                        }
                    });
                    return false;
                });

                $(".editColumn").on("click", "button", function () {
                    if ($(this).text() == "Cancel") {
                        removeButtons();
                        resetBack();
                    }
                    else if ($(this).text() == "Save") {
                        var newValues = $(this).parents("tr").find("td:nth-child(1)").text() + ",";

                        var inputs = $(this).parents("tr").find("input[type='text']");
                        $(inputs).each(function (index, value) {
                            newValues += $(value).val() + ',';
                        });

                        saveButton = $(this);
                        $.ajax({
                            type: "POST",
                            url: "index.aspx/updateproduct",
                            contentType: "application/json; charset=utf-8",
                            data: '{"productData":"' + newValues + '"}',
                            dataType: "json",
                            success: function (result, status, xhr) {
                                if (result.d == "success") {
                                    var inputs = $(saveButton).parents("tr").find("input[type='text']");
                                    $(inputs).each(function (index, value) {
                                        $(this).siblings("span").text($(value).val());
                                    });
                                    removeButtons();
                                    resetBack();
                                }
                                else {
                                    removeButtons();
                                    resetBack();
                                }
                            },
                            error: function (xhr, status, error) {
                                removeButtons();
                                resetBack();
                                console.log("Result: " + status + " " + error + " " + xhr.status + " " + xhr.statusText)
                            }
                        });
                    }
                    return false;
                });

                $(document).ajaxStart(function () {
                    $("#loadingImg").show();
                });

                $(document).ajaxStop(function () {
                    $("#loadingImg").hide();
                });

                function removeButtons() {
                    $(".save").remove();
                    $(".cancel").remove();
                }

                function addButtons(editButton) {
                    $(editButton).parent().append("<button class='save'>Save</button><button class='cancel'>Cancel</button>")
                }

                function resetBack() {
                    $(".added").remove();
                    $("span:hidden").show();
                }
            });
        </script>
    </form>
</body>
</html>
