﻿using System;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI.WebControls;

public partial class aspnet_gridview_update_jquery_index : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            BindGridView();
    }

    [WebMethod]
    public static string UpdateProduct(string productData)
    {
        System.Threading.Thread.Sleep(2000);
        CreateDataTable(productData);
        return "success";
    }

    public static void CreateDataTable(string productData = "")
    {
        DataTable dataTable = (DataTable)HttpContext.Current.Session["DataTable"];

        if (dataTable == null)
        {
            dataTable = new DataTable();
            DataColumn[] dataColumn = new DataColumn[]
            {
                new DataColumn("Id"),
                new DataColumn("Name"),
                new DataColumn("Quantity"),
                new DataColumn("Price")
            };

            dataTable.Columns.AddRange(dataColumn);
            dataTable.Rows.Add(new object[] { 1, "Pants", 5, 10 });
            dataTable.Rows.Add(new object[] { 2, "Shirts", 6, 5 });
            dataTable.Rows.Add(new object[] { 3, "Shoes", 7, 8 });
            dataTable.Rows.Add(new object[] { 4, "Socks", 8, 9 });
            dataTable.Rows.Add(new object[] { 5, "TVs", 4, 99 });
            dataTable.Rows.Add(new object[] { 6, "CDs", 5, 2 });
            dataTable.Rows.Add(new object[] { 7, "Keyboards", 8, 3 });
            dataTable.Rows.Add(new object[] { 8, "Mouses", 3, 5 });
            dataTable.Rows.Add(new object[] { 9, "Laptops", 6, 199 });
            dataTable.Rows.Add(new object[] { 10, "Desktops", 7, 299 });
            dataTable.Rows.Add(new object[] { 11, "Speakers", 6, 19 });
            dataTable.Rows.Add(new object[] { 12, "Bulbs", 18, 55 });
            dataTable.Rows.Add(new object[] { 13, "Playstations", 88, 44 });

            HttpContext.Current.Session["DataTable"] = dataTable;
        }
        else
        {
            if (productData != "")
            {
                dataTable.AsEnumerable().Where(a => Convert.ToInt32(a["Id"]) == Convert.ToInt32(productData.Split(',')[0])).ToList().ForEach(a => { a["Name"] = productData.Split(',')[1]; a["Quantity"] = productData.Split(',')[2]; a["Price"] = productData.Split(',')[3]; });
                HttpContext.Current.Session["DataTable"] = dataTable;
            }
        }
    }

    void BindGridView()
    {
        CreateDataTable();
        gridView.DataSource = (DataTable)HttpContext.Current.Session["DataTable"];
        gridView.DataBind();
    }

    protected void gridView_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        gridView.PageIndex = e.NewPageIndex;
        BindGridView();
    }
}